#include "HBWrap.h"

using namespace std;

//Constructor (see also header)
void HBobject::InitialiseHiggsBounds(){
  initialize_higgsbounds_int_(nHzero,nHplus,whichanalyses);
  allocate_arrays();
}

void HBobject::rewrite_values(int nHzero_in,int nHplus_in,int whichanalyses_in,int whichinput_in){
  
  nHzero=nHzero_in;
  nHplus=nHplus_in;
  whichanalyses=whichanalyses_in;
  whichinput=whichinput_in;
}

//Dynamic memory allocation of arrays that are needed and initialise to zero
void HBobject::allocate_arrays(void){
//Hadronic TypeInput variables
  Mh= new double [nHzero];
  MhGammaTot=new double [nHzero];
  CP=new int [nHzero];
  CS_lep_hjZ_ratio=new double [nHzero];
  CS_lep_bbhj_ratio=new double [nHzero];
  CS_lep_tautauhj_ratio=new double [nHzero];
  CS_lep_hjhi_ratio=new double * [nHzero]; //THIS IS A MATRIX!!!
  CS_lep_hjhi_ratio_f90=new double [nHzero*nHzero]; //THIS IS A MATRIX!!!
  CS_tev_hj_ratio=new double [nHzero];
  CS_tev_hjb_ratio=new double [nHzero];
  CS_tev_hjW_ratio=new double [nHzero];
  CS_tev_hjZ_ratio=new double [nHzero];
  CS_tev_vbf_ratio=new double [nHzero]; 
  CS_tev_tthj_ratio=new double [nHzero];
  CS_lhc7_hj_ratio=new double [nHzero];
  CS_lhc7_hjb_ratio=new double [nHzero];
  CS_lhc7_hjW_ratio=new double [nHzero];
  CS_lhc7_hjZ_ratio=new double [nHzero];
  CS_lhc7_vbf_ratio=new double [nHzero];
  CS_lhc7_tthj_ratio=new double [nHzero];
  CS_lhc8_hj_ratio=new double [nHzero];
  CS_lhc8_hjb_ratio=new double [nHzero];
  CS_lhc8_hjW_ratio=new double [nHzero];
  CS_lhc8_hjZ_ratio=new double [nHzero];
  CS_lhc8_vbf_ratio=new double [nHzero];
  CS_lhc8_tthj_ratio=new double [nHzero];
  BR_hjss=new double [nHzero];
  BR_hjcc=new double [nHzero];
  BR_hjbb=new double [nHzero];
  BR_hjtt=new double [nHzero];
  BR_hjmumu=new double [nHzero];
  BR_hjtautau=new double [nHzero];
  BR_hjWW=new double [nHzero];
  BR_hjZZ=new double [nHzero];
  BR_hjZga=new double [nHzero];
  BR_hjgaga=new double [nHzero];
  BR_hjgg=new double [nHzero];
  BR_hjinvisible=new double [nHzero];
  BR_hjhihi=new double * [nHzero]; //THIS IS A MATRIX!!!
  BR_hjhihi_f90=new double [nHzero*nHzero]; //THIS IS A MATRIX!!!
  
 //Partonic type input variables, which are not also above
 CS_gg_hj_ratio=new double [nHzero];
 CS_bb_hj_ratio=new double [nHzero];
 CS_bg_hjb_ratio=new double [nHzero];
 CS_ud_hjWp_ratio=new double [nHzero];
 CS_cs_hjWp_ratio=new double [nHzero];
 CS_ud_hjWm_ratio=new double [nHzero];
 CS_cs_hjWm_ratio=new double [nHzero];
 CS_gg_hjZ_ratio=new double [nHzero];
 CS_dd_hjZ_ratio=new double [nHzero];
 CS_uu_hjZ_ratio=new double [nHzero];
 CS_ss_hjZ_ratio=new double [nHzero];
 CS_cc_hjZ_ratio=new double [nHzero];
 CS_bb_hjZ_ratio=new double [nHzero];

 //effective coupling variables
 g2hjss_s=new double [nHzero];
 g2hjss_p=new double [nHzero];
 g2hjcc_s=new double [nHzero];
 g2hjcc_p=new double [nHzero];
 g2hjbb_s=new double [nHzero];
 g2hjbb_p=new double [nHzero];
 g2hjtoptop_s=new double [nHzero];
 g2hjtoptop_p=new double [nHzero];
 g2hjmumu_s=new double [nHzero];
 g2hjmumu_p=new double [nHzero];
 g2hjtautau_s=new double [nHzero];
 g2hjtautau_p=new double [nHzero];
 g2hjWW=new double [nHzero];
 g2hjZZ=new double [nHzero];
 g2hjZga=new double [nHzero];
 g2hjgaga=new double [nHzero];
 g2hjgg=new double [nHzero];
 g2hjggZ=new double [nHzero];
 g2hjhiZ=new double * [nHzero];//THIS IS A MATRIX!!!
 g2hjhiZ_f90=new double [nHzero*nHzero];//THIS IS A MATRIX!!!

 for(size_t i=0;i<nHzero;++i){
   CS_lep_hjhi_ratio[i]=new double [nHzero]; //THIS IS A MATRIX!!!
   g2hjhiZ[i]=new double [nHzero];//THIS IS A MATRIX!!!
   BR_hjhihi[i]=new double [nHzero]; //THIS IS A MATRIX!!!
 }
 //Charged Higgses
 MHplus=new double [nHplus];
 MHplusGammaTot=new double [nHplus];
 CS_lep_HpjHmi_ratio=new double [nHplus];
 BR_tWpb=new double [nHplus];
 BR_tHpjb=new double [nHplus];
 BR_Hpjcs=new double [nHplus];
 BR_Hpjcb=new double [nHplus];
 BR_Hptaunu=new double [nHplus];

 //Initialise everything to zero
 for(size_t i=0;i<nHzero;++i){
   Mh[i]=0;
   MhGammaTot[i]=0;
   CP[i]=0;
   CS_lep_hjZ_ratio[i]=0;
   CS_lep_bbhj_ratio[i]=0;
   CS_lep_tautauhj_ratio[i]=0;
   CS_tev_hj_ratio[i]=0;
   CS_tev_hjb_ratio[i]=0;
   CS_tev_hjW_ratio[i]=0;
   CS_tev_hjZ_ratio[i]=0;
   CS_tev_vbf_ratio[i]=0; 
   CS_tev_tthj_ratio[i]=0;
   CS_lhc7_hj_ratio[i]=0;
   CS_lhc7_hjb_ratio[i]=0;
   CS_lhc7_hjW_ratio[i]=0;
   CS_lhc7_hjZ_ratio[i]=0;
   CS_lhc7_vbf_ratio[i]=0;
   CS_lhc7_tthj_ratio[i]=0;
   CS_lhc8_hj_ratio[i]=0;
   CS_lhc8_hjb_ratio[i]=0;
   CS_lhc8_hjW_ratio[i]=0;
   CS_lhc8_hjZ_ratio[i]=0;
   CS_lhc8_vbf_ratio[i]=0;
   CS_lhc8_tthj_ratio[i]=0;
   BR_hjss[i]=0;
   BR_hjcc[i]=0;
   BR_hjbb[i]=0;
   BR_hjmumu[i]=0;
   BR_hjtautau[i]=0;
   BR_hjWW[i]=0;
   BR_hjZZ[i]=0;
   BR_hjZga[i]=0;
   BR_hjgaga[i]=0;
   BR_hjgg[i]=0;
   BR_hjinvisible[i]=0;
   
   //Partonic type input variables, which are not also above
   CS_gg_hj_ratio[i]=0;
   CS_bb_hj_ratio[i]=0;
   CS_bg_hjb_ratio[i]=0;
   CS_ud_hjWp_ratio[i]=0;
   CS_cs_hjWp_ratio[i]=0;
   CS_ud_hjWm_ratio[i]=0;
   CS_cs_hjWm_ratio[i]=0;
   CS_gg_hjZ_ratio[i]=0;
   CS_dd_hjZ_ratio[i]=0;
   CS_uu_hjZ_ratio[i]=0;
   CS_ss_hjZ_ratio[i]=0;
   CS_cc_hjZ_ratio[i]=0;
   CS_bb_hjZ_ratio[i]=0;
   
   //effective coupling variables
   g2hjss_s[i]=0;
   g2hjss_p[i]=0;
   g2hjcc_s[i]=0;
   g2hjcc_p[i]=0;
   g2hjbb_s[i]=0;
   g2hjbb_p[i]=0;
   g2hjtoptop_s[i]=0;
   g2hjtoptop_p[i]=0;
   g2hjmumu_s[i]=0;
   g2hjmumu_p[i]=0;
   g2hjtautau_s[i]=0;
   g2hjtautau_p[i]=0;
   g2hjWW[i]=0;
   g2hjZZ[i]=0;
   g2hjZga[i]=0;
   g2hjgaga[i]=0;
   g2hjgg[i]=0;
   g2hjggZ[i]=0;
 }

 for(size_t i=0;i<nHzero;++i){
   for(size_t j=0;j<nHzero;++j){
     CS_lep_hjhi_ratio[i][j]=0;//THIS IS A MATRIX!!!
     CS_lep_hjhi_ratio_f90[i+nHzero*j]=0;//THIS IS A MATRIX!!!
     BR_hjhihi[i][j]=0; //THIS IS A MATRIX!!!
     g2hjhiZ[i][j]=0;//THIS IS A MATRIX!!!
     BR_hjhihi_f90[i+nHzero*j]=0; //THIS IS A MATRIX!!!
     g2hjhiZ_f90[i+nHzero*j]=0;//THIS IS A MATRIX!!!
   }
 }

 //Charged Higgses
 for(size_t i=0;i<nHplus;++i){
   MHplus[i]=0;
   MHplusGammaTot[i]=0;
   CS_lep_HpjHmi_ratio[i]=0;
   BR_tWpb[i]=0;
   BR_tHpjb[i]=0;
   BR_Hpjcs[i]=0;
   BR_Hpjcb[i]=0;
   BR_Hptaunu[i]=0;
 }
}

//Run HiggsBounds
void HBobject::run(int & HBresult, int & chan, double & obsratio,int & ncombined){
  input();
  run_higgsbounds_(HBresult,chan,obsratio,ncombined);
}

//Pass input information to Higgs Bounds
void HBobject::input(void){
  set_f90_matrices();
  if(nHplus>0)
    higgsbounds_charged_input_(MHplus,MHplusGammaTot,CS_lep_HpjHmi_ratio,BR_tWpb,BR_tHpjb,BR_Hpjcs,BR_Hpjcb,BR_Hptaunu);

  if(whichinput==1){
    higgsbounds_neutral_input_hadr_(Mh,MhGammaTot,CP,CS_lep_hjZ_ratio,CS_lep_bbhj_ratio,CS_lep_tautauhj_ratio,CS_lep_hjhi_ratio_f90,CS_tev_hj_ratio,CS_tev_hjb_ratio,CS_tev_hjW_ratio,CS_tev_hjZ_ratio,CS_tev_vbf_ratio,CS_tev_tthj_ratio,CS_lhc7_hj_ratio,CS_lhc7_hjb_ratio,CS_lhc7_hjW_ratio,CS_lhc7_hjZ_ratio,CS_lhc7_vbf_ratio,CS_lhc7_tthj_ratio,CS_lhc8_hj_ratio,CS_lhc8_hjb_ratio,CS_lhc8_hjW_ratio,CS_lhc8_hjZ_ratio,CS_lhc8_vbf_ratio,CS_lhc8_tthj_ratio,BR_hjss,BR_hjcc,BR_hjbb,BR_hjmumu,BR_hjtautau,BR_hjWW,BR_hjZZ,BR_hjZga,BR_hjgaga,BR_hjgg,BR_hjinvisible,BR_hjhihi_f90);
  }
  else if(whichinput==2){
    higgsbounds_neutral_input_part_(Mh,MhGammaTot,CP,CS_lep_hjZ_ratio,CS_lep_bbhj_ratio,CS_lep_tautauhj_ratio,CS_lep_hjhi_ratio_f90,CS_gg_hj_ratio,CS_bb_hj_ratio,CS_bg_hjb_ratio,CS_ud_hjWp_ratio,CS_cs_hjWp_ratio,CS_ud_hjWm_ratio,CS_cs_hjWm_ratio,CS_gg_hjZ_ratio,CS_dd_hjZ_ratio,CS_uu_hjZ_ratio,CS_ss_hjZ_ratio,CS_cc_hjZ_ratio,CS_bb_hjZ_ratio,CS_tev_vbf_ratio,CS_tev_tthj_ratio,CS_lhc7_vbf_ratio,CS_lhc7_tthj_ratio,CS_lhc8_vbf_ratio,CS_lhc8_tthj_ratio,BR_hjss,BR_hjcc,BR_hjbb,BR_hjmumu,BR_hjtautau,BR_hjWW,BR_hjZZ,BR_hjZga,BR_hjgaga,BR_hjgg,BR_hjinvisible,BR_hjhihi_f90);
  }
  else if(whichinput==3){
    higgsbounds_neutral_input_effc_(Mh,MhGammaTot,g2hjss_s,g2hjss_p,g2hjcc_s,g2hjcc_p,g2hjbb_s,g2hjbb_p,g2hjtoptop_s,g2hjtoptop_p,g2hjmumu_s,g2hjmumu_p,g2hjtautau_s,g2hjtautau_p,g2hjWW,g2hjZZ,g2hjZga,g2hjgaga,g2hjgg,g2hjggZ,g2hjhiZ_f90,BR_hjinvisible,BR_hjhihi_f90);
  }
  else{
    cerr<<"Error in void HBobject::input(void): Bad whichinput variable = "<<whichinput<<". Valid options are 1 (hardronic), 2 (partonic), 3 (effective couplings)."<< endl;
    exit(EXIT_FAILURE);
  }

}

//Set the values of the f90 matrices that will be passed, by using the (more intuitive) ones that the user has access to
void HBobject::set_f90_matrices(void){
  for(size_t i=0;i<nHzero;++i){
    for(size_t j=0;j<nHzero;++j){
      CS_lep_hjhi_ratio_f90[i+nHzero*j]=CS_lep_hjhi_ratio[j][i];
      g2hjhiZ_f90[i+nHzero*j]=g2hjhiZ[j][i];
      BR_hjhihi_f90[i+nHzero*j]=BR_hjhihi[i][j];
    }
  }
}
 
//Free all allocated memory 
HBobject::~HBobject(void){
  finish_higgsbounds_();
  //Hadronic TypeInput variables
  delete [] Mh;
  delete [] MhGammaTot;
  delete [] CP;
  delete [] CS_lep_hjZ_ratio;
  delete [] CS_lep_bbhj_ratio;
  delete [] CS_lep_tautauhj_ratio;
  delete [] CS_tev_hj_ratio;
  delete [] CS_tev_hjb_ratio;
  delete [] CS_tev_hjW_ratio;
  delete [] CS_tev_hjZ_ratio;
  delete [] CS_tev_vbf_ratio; 
  delete [] CS_tev_tthj_ratio;
  delete [] CS_lhc7_hj_ratio;
  delete [] CS_lhc7_hjb_ratio;
  delete [] CS_lhc7_hjW_ratio;
  delete [] CS_lhc7_hjZ_ratio;
  delete [] CS_lhc7_vbf_ratio;
  delete [] CS_lhc7_tthj_ratio;
  delete [] CS_lhc8_hj_ratio;
  delete [] CS_lhc8_hjb_ratio;
  delete [] CS_lhc8_hjW_ratio;
  delete [] CS_lhc8_hjZ_ratio;
  delete [] CS_lhc8_vbf_ratio;
  delete [] CS_lhc8_tthj_ratio;
  delete [] BR_hjss;
  delete [] BR_hjcc;
  delete [] BR_hjbb;
  delete [] BR_hjmumu;
  delete [] BR_hjtautau;
  delete [] BR_hjWW;
  delete [] BR_hjZZ;
  delete [] BR_hjZga;
  delete [] BR_hjgaga;
  delete [] BR_hjgg;
  delete [] BR_hjinvisible;
  
 //Partonic type input variables, which are not also above
 delete [] CS_gg_hj_ratio;
 delete [] CS_bb_hj_ratio;
 delete [] CS_bg_hjb_ratio;
 delete [] CS_ud_hjWp_ratio;
 delete [] CS_cs_hjWp_ratio;
 delete [] CS_ud_hjWm_ratio;
 delete [] CS_cs_hjWm_ratio;
 delete [] CS_gg_hjZ_ratio;
 delete [] CS_dd_hjZ_ratio;
 delete [] CS_uu_hjZ_ratio;
 delete [] CS_ss_hjZ_ratio;
 delete [] CS_cc_hjZ_ratio;
 delete [] CS_bb_hjZ_ratio;

 //effective coupling variables
 delete [] g2hjss_s;
 delete [] g2hjss_p;
 delete [] g2hjcc_s;
 delete [] g2hjcc_p;
 delete [] g2hjbb_s;
 delete [] g2hjbb_p;
 delete [] g2hjtoptop_s;
 delete [] g2hjtoptop_p;
 delete [] g2hjmumu_s;
 delete [] g2hjmumu_p;
 delete [] g2hjtautau_s;
 delete [] g2hjtautau_p;
 delete [] g2hjWW;
 delete [] g2hjZZ;
 delete [] g2hjZga;
 delete [] g2hjgaga;
 delete [] g2hjgg;
 delete [] g2hjggZ;

 for(size_t i=0;i<nHzero;++i){
   delete [] CS_lep_hjhi_ratio[i]; //THIS IS A MATRIX!!!
   delete [] BR_hjhihi[i]; //THIS IS A MATRIX!!!
   delete [] g2hjhiZ[i]; //THIS IS A MATRIX!!!
 }

 delete [] CS_lep_hjhi_ratio_f90; //THIS IS A MATRIX!!
 delete [] CS_lep_hjhi_ratio; //THIS IS A MATRIX!!
 delete [] BR_hjhihi; //THIS IS A MATRIX!!!
 delete [] g2hjhiZ; //THIS IS A MATRIX!!!
 delete [] BR_hjhihi_f90; //THIS IS A MATRIX!!!
 delete [] g2hjhiZ_f90; //THIS IS A MATRIX!!!

 //Charged Higgses
 delete [] MHplus;
 delete [] MHplusGammaTot;
 delete [] CS_lep_HpjHmi_ratio;
 delete [] BR_tWpb;
 delete [] BR_tHpjb;
 delete [] BR_Hpjcs;
 delete [] BR_Hpjcb;
 delete [] BR_Hptaunu;
}
