#ifndef SCANNERSXSM2_H
#define SCANNERSXSM2_H
#include <iostream>
#include <cmath>
#include "../../ScannerSInterface.h"
#include "../../ScannerSModelclasses.h"
#include "../../ScannerSTables.h"
#include "../../ScannerSEWPO.h"

#include "../../ExtInterfaces/Wrappers.h"

class xSM2:public Potential{

    static std::string filepath;
    static int nHzero;
    static int nHplus;
    static int whichanalyses;	//which Higgs bounds analysis
    static int whichinput; 	//which type of input you will provide (1=hadronic)
#ifdef HBMODE
    HBobject HiggsBoundsAnalysis;
    bool PrepareHiggsBoundsInput();
#endif
    const double Gamma_const;
    double Pvalue,BRfrac,Omega,sigmaSI3,sigmaup,csqmu,csqmh,csqtot,obsratio;
    int  nobs,HBresult,chan,ncombined;
    double g011,g022,g012,g100,g122,g200,g211;
    double Gamma011,Gamma012,Gamma022,Gamma100,Gamma102,Gamma122,Gamma200,Gamma201,Gamma211;
    double GammaS[3],GammaOrdered[4];
    double alpha[4];	//alpha[0] is a dummy variable
    void OrderGammas(void);
    size_t h[3]; // Positions of ordered higgses to be computed
    bool DM_candidate;
    bool mass_bounds[3],L_bounds[7],phi_bounds[6];
    static void beta_func(const double t, const std::vector<double> & y,std::vector<double> & dydt, void * par);
  public:
    xSM2();
    double compute_scalar_widths();
    void compute_alphas();
    std::string name() const;
    void PrintHeader() const;
    void readfile(std::istream & in);
    void UserInitCalcs();
    void what2print();
    void UserFinalCalcs(void);
    bool CheckBounds() const;
    bool CheckStability(LambdaRef & L)const;
    bool CheckGlobal(PhiRef & Phi0,LambdaRef & L0,Potential & V)const;
    bool UserAnalysis(PhiRef & Phi,LambdaRef & L,MassRef & Mass, MmixingRef & Mixing);
    
    void MyPhiParametrization(const PhiParamVec & PhiPar,PhiVec & Phi);
    void MyInternalMixing(const PhiParamVec & PhiPar,const PhiVec & Phi,MixingparamVec & MixPar,std::vector< std::vector<double> > & MixInternal);
    void MyCoupMassRelations(const PhiParamVec & PhiPar,const PhiVec & Phi,const std::vector< std::vector<double> > & Mixing,const MixingparamVec & MixPar,std::vector<double> & L,std::vector<double> & Mass, MLparamVec & MLPar, std::vector<double> & IndependentMs,std::vector<double> & IndependentLs);

#ifdef MICROMEGASMODE
    void assignMOvalues();
#endif

};

bool RGE_Stop_criteria(const std::vector<double> & y,void *pvoid);

#endif
